struct ObAttr {
  char *name;
  char *value;
  struct ObAttr *next;
};

struct CObligation {
  struct CObligation *next;
  char *id;
  struct ObAttr *params;
  int condition;
};

struct Result {
  int result;
  struct CObligation *ob;
  char * name;
  struct Result *next;
};

#define TYPE_SUBJ 0
#define TYPE_RES  1
#define TYPE_ACT  2

#define TYPE_TIME   0
#define TYPE_STRING 1
#define TYPE_BOOL   2
#define TYPE_INT    3
#define TYPE_DATE   4
#define TYPE_URI    5

#define ANS_DENY   0
#define ANS_PERMIT 1
#define ANS_INDET  2
#define ANS_NOTA   3

extern void FreeObligations(struct CObligation *);
extern void FreeResults(struct Result *);
extern void *PEPClientInit(int);
extern void FreeAttrs(void *);
extern int PEPClientSend(void *, void *, const char *, const char *cert, int, int, int, struct Result **);
extern void *PEPEstablish(const char *, int, const char *, int);
extern void PEPClientDestroy(void *);
extern int SetResource(void *, const char *);
extern int SetAction(void *, const char *);
extern int SetSubject(void *, const char *);
extern void *CreateAttr(const char *, const char *, unsigned int);
extern void *AddAttr(void *, const char *, const char *, unsigned int);
extern void *AddAttrList(void *, void *);
extern void SetAttr(void *, void *, int);
extern char *AttrName(void *);
extern char *AttrValue(void *);
extern int   AttrType(void *);
